local assets=
{
    Asset("ANIM", "anim/back.zip"),
    Asset("ANIM", "anim/back_sw.zip"),

    Asset("ANIM", "anim/ui_backpack_4x10.zip"),
    Asset("ATLAS", "images/back.xml"),
    Asset("IMAGE", "images/back.tex"),


}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour") 
end


local function onequip(inst, owner) 
 
    owner.AnimState:OverrideSymbol("swap_body", "back_sw", "swap_body")
    inst:ListenForEvent("blocked", OnBlocked, owner)
    
    owner.components.inventory:SetOverflow(inst)
    inst.components.container:Open(owner)
    
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    inst:RemoveEventCallback("blocked", OnBlocked, owner)

    owner.components.inventory:SetOverflow(nil)
    inst.components.container:Close(owner)
    
end


local function onopen(inst)
	inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_open", "open")
end

local function onclose(inst)
	inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_close", "open")
end


local slotpos = {}

for y = 0, 9 do
	table.insert(slotpos, Vector3(-75*1.6  +75*0 , -y*75 +75*4.3 ,0))
    table.insert(slotpos, Vector3(-75*1.6  +75*1 , -y*75 +75*4.3 ,0))
    table.insert(slotpos, Vector3(-75*1.6  +75*2 , -y*75 +75*4.3 ,0))
	table.insert(slotpos, Vector3(-75*1.6  +75*3 , -y*75 +75*4.3 ,0))
end

local function fn(Sim)
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("back")
    inst.AnimState:SetBuild("back")
    inst.AnimState:PlayAnimation("anim")

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("backpack.png")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
     inst.components.inventoryitem.cangoincontainer = false
    inst.components.inventoryitem.atlasname = "images/back.xml"

    inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMORGRASS, TUNING.ARMORGRASS_ABSORPTION)

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    inst.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT*3
    
    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_4x10"
    inst.components.container.widgetanimbuild = "ui_backpack_4x10"
    inst.components.container.widgetpos = Vector3(75*(-1.5), 75*(-1) ,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "pack"
   
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
 
    
    return inst
end

return Prefab( "back", fn, assets) 
