local assets =
{
 
    Asset("ANIM", "anim/sword.zip"),
    Asset("ANIM", "anim/sword_sw.zip"),

 
    Asset("ATLAS", "images/sword.xml"),
    Asset("IMAGE", "images/sword.tex"),
}

    



local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
   
   owner.AnimState:OverrideSymbol("swap_object", "sword_sw", "sword_sw")
	 
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal")
    inst.Light:Enable(true)
end

local function onunequip(inst, owner) 
     	

    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
    inst.Light:Enable(false)
end



local function Set_light(inst)
    inst:AddTag("light")   
    local fuelpercent = .5
    inst.entity:AddLight()
    inst.Light:SetColour(180/255, 195/255, 150/255)
    inst.Light:SetIntensity(Lerp(0.4, 0.6, fuelpercent))
    inst.Light:SetRadius(Lerp(3, 5, fuelpercent))
    inst.Light:SetFalloff(.9)
end
 

local function fn(Sim)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
 MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("sword")
    inst.AnimState:SetBuild("sword")
    inst.AnimState:PlayAnimation("idle")


    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.HACK, 3)
    inst.components.tool:SetAction(ACTIONS.CHOP, 3)
    inst.components.tool:SetAction(ACTIONS.HAMMER, 3)
    inst.components.tool:SetAction(ACTIONS.MINE, 3)
    inst.components.tool:SetAction(ACTIONS.DIG)
    
    Set_light(inst)
   

    inst:AddTag("sharp")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(40*3)
    inst.components.weapon:SetRange(1.5*3)

     


    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/sword.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip ) 
    inst.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT*4




    return inst
end

return Prefab("sword", fn, assets)


